
/*
 * Для голосований и добавления в избранное
 * @param  obj       Указатель на объект ДОМа
 * @param  obj_type  Тип объекта (новость, комментарий, пользователь)
 * @param  obj_id    ID объекта
 */
function simple_set(obj, obj_type, obj_id, vdouble) {
	var url = jQuery(obj).attr('href');
	var ajax_type =
		url.indexOf('/ajax/vote') != -1 ? 'vote' :
		url.indexOf('/ajax/fav/add') != -1 ? 'fav_add' :
		url.indexOf('/ajax/fav/del') != -1 ? 'fav_del' :
		'';
	if (ajax_type == '')
		return false;
	jQuery.ajax({
		url: url,
		type: 'GET',
		dataType: 'json',
		beforeSend: function(){
			jQuery(obj).addClass('proceeding');
		},
		complete: function(XMLHttpRequest, textStatus){
			jQuery(obj).removeClass("proceeding");
		},
		success: function(data, textStatus, XMLHttpRequest){
			if (vdouble) {
				jQuery(obj).parent().parent().html(data);
			} else {
				jQuery(obj).parent().html(data);
			}
		},
		error: function(XMLHttpRequest, textStatus, errorThrown){}
	});

	return false;
}

function poll(obj) {
	var url = jQuery(obj).attr('action');
        
    var fields = jQuery(obj).find(":input");
    var cnt_checked = 0
    fields.each(
        function () {
            if (this.checked == true)
                ++cnt_checked;
        });
    if (cnt_checked == 0)
    {
        alert("Нужно выбрать вариант ответа");
        return false;
    }
  
    jQuery.ajax({
		url: url,
		type: 'POST',
		data: fields.serialize(),
		beforeSend: function(){
			jQuery(obj).addClass('proceeding');
		},
		complete: function(XMLHttpRequest, textStatus){
			jQuery(obj).removeClass("proceeding");
		},
		success: function(response, textStatus, XMLHttpRequest){
            
            jQuery(obj).parent().html(response);
        },
		error: function(XMLHttpRequest, textStatus, errorThrown){}
	});

	return false;
}

function refrain(obj) {
	var url = jQuery(obj).attr('href');
    
    var form = jQuery(obj).parent().parent();
    
    jQuery.ajax({
		url: url,
		type: 'GET',
		beforeSend: function(){
			form.addClass('proceeding');
		},
		complete: function(XMLHttpRequest, textStatus){
			form.removeClass("proceeding");
		},
		success: function(response, textStatus, XMLHttpRequest){
            
            form.parent().html(response);
        },
		error: function(XMLHttpRequest, textStatus, errorThrown){}
	});

	return false;
}

function ch(elem) {
	var id = $(elem).attr('id').replace('news_change_category_', '');
	if ($(elem).attr('checked')) {
		$('select#new_category_' + id).removeAttr("disabled");
	} else {
		$('select#new_category_' + id).attr('disabled', 'disabled');
	}
}

$(function() {
	if ($('#comments').length > 0) {
		var vcom = $('.comments_list').offset().top;
		$(window).scroll(function() {
			if($(this).scrollTop() > vcom)
				$('#toComments').fadeIn();	
			else
				$('#toComments').fadeOut();
		});
		$('#toComments').click(function(){
			$('body,html').animate({scrollTop:$('#comments').offset().top},50);
		});
	}
	$(window).scroll(function() {
		if($(this).scrollTop() != 0)
			$('#toTop').fadeIn();	
		else
			$('#toTop').fadeOut();
	});
	$('#toTop').click(function() {
		$('body,html').animate({scrollTop:0},50);
	});
	$('input.cat_checkbox').change(function() {
		ch(this);
	});
	$(document).ready(function() {
		$('input.cat_checkbox').each(function() {
			ch(this);
		});
		
		/* for keeping track of what's "open" */
		var activeClass = 'uiCloseButtonMenu-active', showingDropdown, showingMenu, showingParent;
		/* hides the current menu */
		var hideMenu = function() {
			if(showingDropdown) {
				showingDropdown.removeClass(activeClass);
				$('.uiCloseButton').hide();
				showingMenu.hide();
			}
		};
		
		$('.article')
			.mouseover(function(){
				$(this).find('.uiCloseButton:hidden').show();
			})
			.mouseout(function(){
				if (!$(this).find('.uiCloseButton').hasClass('uiCloseButtonMenu-active'))
					$(this).find('.uiCloseButton').hide();
			});

		/* recurse through dropdown menus */
		$('.uiCloseButton').each(function() {
			/* track elements: menu, parent */
			var dropdown = $(this);
			var menu = dropdown.next('.uiCloseButtonMenu'), parent = dropdown.parent();
			/* function that shows THIS menu */
			var showMenu = function() {
				hideMenu();
				showingDropdown = dropdown.addClass('uiCloseButtonMenu-active');
				showingMenu = menu.show();
				showingParent = parent;
			};
			/* function to show menu when clicked */
			dropdown.bind('click',function(e) {
				if(e) e.stopPropagation();
				if(e) e.preventDefault();
				showMenu();
			});
			/* function to show menu when someone tabs to the box */
			dropdown.bind('focus',function() {
				showMenu();
			});
		});
		/* hide when clicked outside */
		$(document.body).bind('click',function(e) {
			if(showingParent) {
				var parentElement = showingParent[0];
				if(!$.contains(parentElement,e.target) || !parentElement == e.target) {
					hideMenu();
				}
			}
		});
		$('a.uiDeletePost').live('click', function(){
			var id = $(this).attr('id').replace('uiDeletePost_', '');
			if (id) {
				var title = $('#n_' + id).find('h3'), type = 'post';
				if (title.find('a').length) {
					title = title.find('a').html();
					type = 'list';
				} else if ($('#news_' + id).find('h3').length) {
					title = $('#news_' + id).find('h3').html();
				} else {
					title = title.html();
				}
				if ('undefined' !== typeof(title) && '' != title && confirm('Вы уверены, что хотите удалить новость "' + title + '"?')) {
					$.ajax({
						url: '/ajax/delete_news/' + id + '/' + user_digest + '/',
						dataType: 'json',
						success: function(data){
							if ('undefined' !== typeof(data.result)) {
								if ('success' == data.result && 'undefined' !== typeof(data.id)) {
									if (type == 'list') {
										$('#n_' + data.id).slideUp('fast');
									} else {
										alert('Новость удалена');
										window.location.reload(true);
									}
								} else if('error' == data.result && 'undefined' !== typeof(data.message)) {
									alert(data.message);
								} else {
									alert('Ответ сервера не распознан, попробуйте снова');
								}
							} else {
								alert('Ошибка ответа сервера');
							}
						},
						error: function(jqXHR, textStatus, errorThrown){
							alert('Ошибка связи с сервером');
						}
					});
				}
			}
			return false;
		});
		$('a.ignore_delete').live('click', function(){
			var obj = this;
			var url = $(obj).attr('href');
			if (undefined == url || '' == url)
				return false;

			$.ajax({
				url: url,
				type: 'GET',
				dataType: 'json',
				beforeSend: function(){
					jQuery(obj).html('<img src="//nnm.me/i/spinner_bar.gif" alt="" />');
				},
				complete: function(XMLHttpRequest, textStatus){
					jQuery(obj).html('<img src="//nnm.me/i/cross-small.png" alt="" />');
				},
				success: function(data, textStatus, XMLHttpRequest){
					if (undefined != data.result) {
						if ('success' == data.result) {
							var parent = $(obj).parent().parent().parent();
							$(obj).parent().parent().remove();
							if ($(parent).find('.ignores').length == 0)
								$(parent).append('<span class="hint">Список пуст</span>');
						} else {
							if (undefined != data.message)
								alert(data.message);
							else
								alert('Неизвестная ошибка');
						}
					} else {
						alert('Ошибка ответа сервера');
					}
				},
				error: function(XMLHttpRequest, textStatus, errorThrown){
					alert('Ошибка связи с сервером');
				}
			});
			
			return false;
		});
	
		$('a.comment_hide').click(function() {
			var id = $(this).attr('id').replace('comment_hide_', '');
			$.ajax({
				type: 'post',
				url: '/ajax/get_comment/',
				data: {id: id},
				dataType: 'html',
				success: function(data, textStatus) {
					var div = 'div#comment_' + id;
					if (data != '') {
						$(div + ' div.comment-content').removeClass('pt10').html(data);
						$(div + ' div.comment_meta').show();
						$(div + ' div.comment_panel').show();
					} else {
						$(div + ' div.comment-content').html('Комментарий удален');
					}
				}
			});
			return false;
		});
		
	});
	if($('.pagination').length > 0) {
		var page = 1;
		var max_page = 1;
		var url = document.location.href;
		var regx = /.*?\/page(\d+)\/(#.*)?/i;
		var p = url.match(regx);
		var postfix = '';
		if (null != p) {
			if(isNaN(page = parseInt(p[1])))
				page = 1;
			postfix = p[2];
		}
		$('.pagination:first').find('span > a').each(function(){
			p = $(this).attr('href').match(regx);
			if (null != p) {
				pp = parseInt(p[1]);
				if (pp > max_page)
					max_page = pp;
			}
		});
		if (page > 1) {
			$(document).bind('keydown','Ctrl+left',function(){
				p = page - 1;
				var u = url.replace(/\/page\d+\//i, '/page' + p + '/');
				if(!regx.test(u))
					u = url + 'page' + p + '/' + postfix;
				window.location = u;
				return false;
			});
		}
		if (max_page > page) {
			$(document).bind('keydown','Ctrl+right',function(){
				p = page + 1;
				var u = url.replace(/\/page\d+\//i, '/page' + p + '/');
				if(!regx.test(u))
					u = url + 'page' + p + '/' + postfix;
				window.location = u;
				return false;
			});
		}
	}
	$('input#send_category').change(function() {
		if ($(this).attr('checked')) {
			$('select.category_select').removeAttr("disabled");
		} else {
			$('select.category_select').attr('disabled', 'disabled');
		}
	});

	$('select#pool_type').change(function(){
		if($(this).val() != 'none')
			$('#poll_data').show();
		else
			$('#poll_data').hide();
	});

	$(function () {
		$("div.system-btn > input.btn").click(function() {
            $("#htmlarea").attr('disabled', false);
            
            var sel_poll_type = $('select#pool_type').val();
            var cur_poll_type = $('#qa_type').val();
            if (
                cur_poll_type != sel_poll_type 
                && (cur_poll_type == 'radio' || cur_poll_type == 'checkbox')
                && sel_poll_type != 'none'
            )
            {
                if ( ! confirm('Если голосование уже велось, то при изменении типа накопленная статистика ответов будет утеряна! Продолжить?'))
                {
                    return false;
                }
            }
        });
	});

	$('#poll_add_answer').click(function() {
		var cnt = $('#poll_data').find('tr').length - 1;
        var num = 1;
        $('#poll_data input').each(function () {
            var name = $(this).attr('name').split('[');
            if (name.length > 1){
                name = name[1].split(']');
            }
            var currVal = parseInt(name);
            
            if (currVal > num)
                num = currVal;
        });

		if (cnt < 11)
        {
			$('<tr><td>Вариант '+cnt+':</td><td><input type="text" name="poll_answers['+(num+1)+']" value="" class="i-text" style="width:333px" /></td></tr>').insertBefore($(this).parent().parent());
            if (cnt == 10)
                $(this).hide();
        }
        if(cnt >= 11)
        {
			$(this).parent().parent().hide();
        }
		return false;
	});

	$('div.article-image img').each(function (idx) {
		var self = $(this);
		var newAlt = [];

		var extractComments = function ($node, type) {
			var cl, cls;
			if (type == 'prev') {
				cl = $node.closest('div.article-image').prevAll();
				cls = 'imgcomment-top';
			} else {
				cl = $node.closest('div.article-image').nextAll();
				cls = 'imgcomment-bottom';
			}

			if ( ! cl || ! cls) {
				return;
			}

			cl.each(function (i) {
				var me = $(this);
				if ( ! me.is('p')) {
					return false;
				}
				var tr = $.trim(me.text());
				if (me.hasClass(cls)) {
					if (tr != '') {
						newAlt.push(tr);
					}
					return false;
				}
				if (tr != '') {
					return false;
				}
			});
		}

		extractComments(self, 'prev');
		extractComments(self, 'next');
		
		if (newAlt.length > 0) {
			var newt = newAlt.join("\n");
			self.attr('alt', newt);
			self.parent('a').attr('title', newt);
		}
	});

	$('div.complain-comment > a').click(function (e) {
		e.preventDefault();

		if ( ! confirm('Вы действительно хотите пожаловаться на комментарий?')) {
			return false;
		}
		var $me = jQuery(this);

		var url = $me.attr('href');
		if (url.indexOf('/complain') == -1) {
			return false;
		}

		var notify = function(success) {
			success = success || 0;
			var o = {title: 'Жалоба не была отправлена',
				text: 'Ваша жалоба на комментарий не отправлена, попробуйте еще раз.',
				time: 3000};
			if (success) {
				o.title = 'Жалоба отправлена';
				o.text = 'Ваша жалоба на комментарий отправлена';
			}
			jQuery.gritter.add(o);
		}

		jQuery.ajax({
			url: url,
			type: 'GET',
			dataType: 'json',
			beforeSend: function(){
				$me.addClass('proceeding');
			},
			complete: function(XMLHttpRequest, textStatus){
				$me.removeClass("proceeding");
			},
			success: function(data, textStatus, XMLHttpRequest){
				$me.parent().hide();

				if (data.error) {
					notify(false);
				} else {
					notify(true);
				}
			},
			error: function(XMLHttpRequest, textStatus, errorThrown){
				notify(false);
			}
		});
	});

	$('a.external-url').click(function () {
		var $el = $(this), url = $el.attr('title');
		if (url) {
			window.open(url);
		}
	});

	$('.mtip').miniTip({
      anchor: 'e'
    });

	var hovered = [];
	$('.teasers-vertical').delegate('.item', 'hover', function () {
		var a = $(this).find('a'), url = '/teasers/service/counth/';
		if (a.length) {
			var href = a.attr('href');
			if (hovered.indexOf(href) === -1) {
				hovered.push(href);
				jQuery.ajax({
					url: url,
					type: 'POST',
					dataType: 'json',
					data:{num:1},
					success: function(data, text, xhr){
						
					}
				});
			}
		}
	});
});
